<link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.4.1/css/bootstrap.min.css">
<script src="https://maxcdn.bootstrapcdn.com/bootstrap/3.4.1/js/bootstrap.min.js"></script>
<%@ taglib prefix="admin" tagdir="/WEB-INF/tags/admin"%>
<%@ taglib prefix="forms" tagdir="/WEB-INF/tags/forms"%>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="bs" tagdir="/WEB-INF/tags" %>
<%@ taglib prefix="props" tagdir="/WEB-INF/tags/props" %>
<%@ taglib prefix="l" tagdir="/WEB-INF/tags/layout" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/functions" prefix="fn" %>
<%@include file="railflowConstants.jsp" %>

<jsp:useBean id="globalRailflowSettings" scope="request" type="io.railflow.teamcity.server.GlobalRailflowSettings"/>

<fmt:setBundle basename="i18n.Messages" var="resourceBundle"/>
<fmt:message key="railflowPublisher.testRailUploadConfigLabel" var="testRailConfigLabel" bundle="${resourceBundle}"/>

<c:set var="testResultFormatsList" value="${fn:split(testResultFormats, ',')}"/>

<l:settingsGroup title="${testRailConfigLabel}">
	<tr>
		<th><fmt:message key="railflowPublisher.testRailServerNameLabel" bundle="${resourceBundle}"/></th>
		<td>
			<props:selectProperty name="${TEST_RAIL_SERVER_NAME}">
				<c:forEach var="testRailserver" items="${globalRailflowSettings.testRailServers}">
					<option value="${testRailserver.value.name}" ${testRailserver.value.name == propertiesBean.properties[TEST_RAIL_SERVER_NAME] ? 'selected="selected"' : ''}>${testRailserver.value.name}
						(${testRailserver.value.url})
					</option>
				</c:forEach>
			</props:selectProperty>
			<span class="smallNote"><fmt:message key="railflowPublisher.testRailServerNameLabelNote"
												 bundle="${resourceBundle}"/></span>
		</td>
	</tr>

	<tr>
		<th><fmt:message key="railflowPublisher.testRailOverridingUserNameLabel" bundle="${resourceBundle}"/></th>
		<td>
			<props:textProperty name="${TEST_RAIL_OVERRIDING_USERNAME}"
								value="${propertiesBean.properties[TEST_RAIL_OVERRIDING_USERNAME]}"
								className="longField"/>
			<span class="error" id="error_${TEST_RAIL_OVERRIDING_USERNAME}"></span>
			<span class="smallNote"><fmt:message key="railflowPublisher.testRailOverridingUserNameNote"
												 bundle="${resourceBundle}"/></span>
		</td>
	</tr>

	<tr>
		<th><fmt:message key="railflowPublisher.testRailOverridingPasswordLabel" bundle="${resourceBundle}"/></th>
		<td>
			<props:passwordProperty name="${TEST_RAIL_OVERRIDING_PASSWORD}" className="longField"/>
			<span class="error" id="error_${TEST_RAIL_OVERRIDING_PASSWORD}"></span>
			<span class="smallNote"><fmt:message key="railflowPublisher.testRailOverridingPasswordNote"
												 bundle="${resourceBundle}"/></span>
		</td>
	</tr>

	<tr>
		<th><fmt:message key="railflowPublisher.projectLabel" bundle="${resourceBundle}"/> <l:star/></th>
		<td>
			<props:textProperty name="${TEST_RAIL_PROJECT}" value="${propertiesBean.properties[TEST_RAIL_PROJECT]}"
								className="longField"/>
			<span class="error" id="error_${TEST_RAIL_PROJECT}"></span>
			<span class="smallNote"><fmt:message key="railflowPublisher.projectNote" bundle="${resourceBundle}"/></span>
		</td>
	</tr>

	<tr>
		<th><fmt:message key="railflowPublisher.failBuildIfUploadUnsuccessfulLabel" bundle="${resourceBundle}"/></th>
		<td>
			<props:checkboxProperty name="${FAIL_BUILD_IF_UPLOAD_FAILS}"/>
			<span class="error" id="error_${FAIL_BUILD_IF_UPLOAD_FAILS}"></span>
			<span class="smallNote"><fmt:message key="railflowPublisher.failBuildIfUploadUnsuccessfulNote"
												 bundle="${resourceBundle}"/></span>
		</td>
	</tr>

	<tr>
		<th><fmt:message key="railflowPublisher.resultFilesPatternLabel" bundle="${resourceBundle}"/> <l:star/></th>
		<td>
			<props:textProperty name="${RESULT_FILES_PATTERN}"
								value="${propertiesBean.properties[RESULT_FILES_PATTERN]}" className="longField"/>
			<span class="error" id="error_${RESULT_FILES_PATTERN}"></span>
			<span class="smallNote"><fmt:message key="railflowPublisher.resultFilesPatternNote"
												 bundle="${resourceBundle}"/></span>
		</td>
	</tr>

	<tr>
		<th><fmt:message key="railflowPublisher.resultFormatLabel" bundle="${resourceBundle}"/> <l:star/></th>
		<td>
			<props:selectProperty name="${RESULT_FORMAT}" id="${RESULT_FORMAT}" onchange="validateTestPath()">
				<c:set var="reportFormat" value="${propertiesBean.properties[RESULT_FORMAT]}"/>
				<c:forEach var="formatOption" items="${testReportFormats}">
					<props:option value="${formatOption.key}" selected="${reportFormat==formatOption.key}"><c:out
							value="${formatOption.value}"/></props:option>
				</c:forEach>
			</props:selectProperty>
			<span class="error" id="error_${RESULT_FORMAT}"></span>
			<span class="smallNote"><fmt:message key="railflowPublisher.resultFormatNote"
												 bundle="${resourceBundle}"/></span>
		</td>
	</tr>

	<tr>
		<th><fmt:message key="railflowPublisher.searchModeLabel" bundle="${resourceBundle}"/> <l:star/></th>
		<td>
			<props:selectProperty name="${SEARCH_MODE}" id="${SEARCH_MODE}">
				<c:set var="searchMode" value="${propertiesBean.properties[SEARCH_MODE]}"/>
				<props:option selected="${searchMode==''}" value="" className="hidden"> </props:option>
				<c:forEach var="modeOption" items="${searchModes}">
					<props:option value="${modeOption.key}" selected="${searchMode==modeOption.key}">
						<c:out value="${modeOption.value}"/>
					</props:option>
				</c:forEach>
			</props:selectProperty>
			<span class="error" id="error_${SEARCH_MODE}"></span>
			<span class="smallNote"><fmt:message key="railflowPublisher.searchModeNote" bundle="${resourceBundle}"/></span>
		</td>
	</tr>

	<tr>
		<th><fmt:message key="railflowPublisher.testPathLabel" bundle="${resourceBundle}"/> <l:star/></th>
		<td>
			<props:textProperty name="${TEST_RAIL_TEST_PATH}" id="${TEST_RAIL_TEST_PATH}" value="${propertiesBean.properties[TEST_RAIL_TEST_PATH]}"
								className="longField" onchange="validateTestPath()"/>
			<span class="error" id="error_${TEST_RAIL_TEST_PATH}"></span>
			<div class="attentionComment clearfix" style="display: none" id="warning_${TEST_RAIL_TEST_PATH}">
				<span class="svg-icon js_buildStatusIcon buildStatusIcon buildStatusIcon_red-sign buildStatusIcon_size_S warningIcon"><svg
						xmlns="http://www.w3.org/2000/svg" width="16" height="16" viewBox="0 0 16 16">
					<path d="M15.83 13.23l-7-11.76a1 1 0 00-1.66 0L.16 13.3c-.38.64-.07 1.7.68 1.7H15.2c.74 0 1.01-1.13.63-1.77zm-7 .37H7.14v-1.71h1.7zm0-3.57H7.16L7 4h2z"></path>
				  </svg>
				</span>
				<div class="global-health-item__content" style="display: inline">&nbsp;${TEST_PATH_WARNING_FOR_TRX_FORMAT}</div>

			</div>
			<span class="smallNote" style=" display: inline"><fmt:message key="railflowPublisher.testPathNote"
																		  bundle="${resourceBundle}"/></span>
		</td>
	</tr>

	<tr>
		<th><fmt:message key="railflowPublisher.testPlanLabel" bundle="${resourceBundle}"/></th>
		<td>
			<props:textProperty name="${TEST_RAIL_TEST_PLAN}" value="${propertiesBean.properties[TEST_RAIL_TEST_PLAN]}"
								className="longField"/>
			<span class="error" id="error_${TEST_RAIL_TEST_PLAN}"></span>
			<span class="smallNote"><fmt:message key="railflowPublisher.testPlanNote"
												 bundle="${resourceBundle}"/></span>
		</td>
	</tr>

	<tr>
		<th><fmt:message key="railflowPublisher.testRunLabel" bundle="${resourceBundle}"/></th>
		<td>
			<props:textProperty name="${TEST_RAIL_TEST_RUN}" value="${propertiesBean.properties[TEST_RAIL_TEST_RUN]}"
								className="longField"/>
			<span class="error" id="error_${TEST_RAIL_TEST_RUN}"></span>
			<span class="smallNote"><fmt:message key="railflowPublisher.testRunNote" bundle="${resourceBundle}"/></span>
		</td>
	</tr>

	<tr>
		<th><fmt:message key="railflowPublisher.testRunIdLabel" bundle="${resourceBundle}"/></th>
		<td>
			<props:textProperty name="${TEST_RAIL_TEST_RUN_ID}" value="${propertiesBean.properties[TEST_RAIL_TEST_RUN_ID]}"
								className="longField"/>
			<span class="error" id="error_${TEST_RAIL_TEST_RUN_ID}"></span>
			<span class="smallNote"><fmt:message key="railflowPublisher.testRunIdNote" bundle="${resourceBundle}"/></span>
		</td>
	</tr>

	<tr>
		<th><fmt:message key="railflowPublisher.milestonePathLabel" bundle="${resourceBundle}"/></th>
		<td>
			<props:textProperty name="${TEST_RAIL_MILESTONES_PATH}"
								value="${propertiesBean.properties[TEST_RAIL_MILESTONES_PATH]}" className="longField"/>
			<span class="error" id="error_${TEST_RAIL_MILESTONES_PATH}"></span>
			<span class="smallNote"><fmt:message key="railflowPublisher.milestonePathNote"
												 bundle="${resourceBundle}"/></span>
		</td>
	</tr>

	<tr>
		<th><fmt:message key="railflowPublisher.smartTestFailureAssignmentLabel" bundle="${resourceBundle}"/></th>
		<td>
			<props:textProperty name="${SMART_TEST_FAILURE_ASSIGNMENT}"
								value="${propertiesBean.properties[SMART_TEST_FAILURE_ASSIGNMENT]}"
								className="longField"/>
			<span class="error" id="error_${SMART_TEST_FAILURE_ASSIGNMENT}"></span>
			<span class="smallNote"><fmt:message key="railflowPublisher.smartTestFailureAssignmentNote"
												 bundle="${resourceBundle}"/></span>
		</td>
	</tr>

	<tr class="advancedSetting">
		<th><fmt:message key="railflowPublisher.caseTypeLabel" bundle="${resourceBundle}"/></th>
		<td>
			<props:textProperty name="${TEST_RAIL_CASE_TYPE}" value="${propertiesBean.properties[TEST_RAIL_CASE_TYPE]}"
								className="longField"/>
			<span class="error" id="error_${TEST_RAIL_CASE_TYPE}"></span>
			<span class="smallNote"><fmt:message key="railflowPublisher.caseTypeNote"
												 bundle="${resourceBundle}"/></span>
		</td>
	</tr>

	<tr class="advancedSetting">
		<th><fmt:message key="railflowPublisher.casePriorityLabel" bundle="${resourceBundle}"/></th>
		<td>
			<props:textProperty name="${TEST_RAIL_CASE_PRIORITY}"
								value="${propertiesBean.properties[TEST_RAIL_CASE_PRIORITY]}" className="longField"/>
			<span class="error" id="error_${TEST_RAIL_CASE_PRIORITY}"></span>
			<span class="smallNote"><fmt:message key="railflowPublisher.casePriorityNote"
												 bundle="${resourceBundle}"/></span>
		</td>
	</tr>

	<tr class="advancedSetting">
		<th><fmt:message key="railflowPublisher.testRailTemplateLabel" bundle="${resourceBundle}"/></th>
		<td>
			<props:textProperty name="${TEST_RAIL_TEMPLATE}" value="${propertiesBean.properties[TEST_RAIL_TEMPLATE]}"
								className="longField"/>
			<span class="error" id="error_${TEST_RAIL_TEMPLATE}"></span>
			<span class="smallNote"><fmt:message key="railflowPublisher.testRailTemplateNote"
												 bundle="${resourceBundle}"/></span>
		</td>
	</tr>

	<tr class="advancedSetting">
		<th><fmt:message key="railflowPublisher.testRailCustomCaseFieldsLabel" bundle="${resourceBundle}"/></th>
		<td>
			<props:multilineProperty name="${TEST_RAIL_CUSTOM_CASE_FIELDS}"
									 value="${propertiesBean.properties[TEST_RAIL_CUSTOM_CASE_FIELDS]}"
									 className="longField" cols="58"
									 rows="5" expanded="true"
									 linkTitle=""/>
			<span class="error" id="error_${TEST_RAIL_CUSTOM_CASE_FIELDS}"></span>
			<span class="smallNote"><fmt:message key="railflowPublisher.testRailCustomCaseFieldsNote"
												 bundle="${resourceBundle}"/></span>
		</td>
	</tr>

	<tr class="advancedSetting">
		<th><fmt:message key="railflowPublisher.customResultFieldsLabel" bundle="${resourceBundle}"/></th>
		<td>
			<props:multilineProperty name="${TEST_RAIL_CUSTOM_RESULT_FIELDS}"
									 value="${propertiesBean.properties[TEST_RAIL_CUSTOM_RESULT_FIELDS]}"
									 className="longField" cols="58" rows="5" expanded="true"
									 linkTitle=""/>
			<span class="error" id="error_${TEST_RAIL_CUSTOM_RESULT_FIELDS}"></span>
			<span class="smallNote"><fmt:message key="railflowPublisher.customResultFieldsNote"
												 bundle="${resourceBundle}"/></span>
		</td>
	</tr>

	<tr class="advancedSetting">
		<th><fmt:message key="railflowPublisher.configNamesLabel" bundle="${resourceBundle}"/></th>
		<td>
			<props:multilineProperty name="${CONFIG_NAME}" value="${propertiesBean.properties[CONFIG_NAME]}"
									 className="longField" cols="58" rows="5"
									 expanded="true"
									 linkTitle=""/>
			<span class="error" id="error_${CONFIG_NAME}"></span>
			<span class="smallNote"><fmt:message key="railflowPublisher.configNamesNote"
												 bundle="${resourceBundle}"/></span>
		</td>
	</tr>

	<tr class="advancedSetting">
		<th><fmt:message key="railflowPublisher.caseSearchFieldLabel" bundle="${resourceBundle}"/></th>
		<td>
			<props:textProperty name="${CASE_SEARCH_FIELD}" value="${propertiesBean.properties[CASE_SEARCH_FIELD]}"
								className="longField"/>
			<span class="error" id="error_${CASE_SEARCH_FIELD}"></span>
			<span class="smallNote"><fmt:message key="railflowPublisher.caseSearchFieldNote"
												 bundle="${resourceBundle}"/></span>
		</td>
	</tr>

	<tr class="advancedSetting">
		<th><fmt:message key="railflowPublisher.tagsFieldNameLabel" bundle="${resourceBundle}"/></th>
		<td>
			<props:textProperty name="${TAGS_FIELD_NAME}" value="${propertiesBean.properties[TAGS_FIELD_NAME]}"
								className="longField"/>
			<span class="error" id="error_${TAGS_FIELD_NAME}"></span>
			<span class="smallNote"><fmt:message key="railflowPublisher.tagsFieldNameNote"
												 bundle="${resourceBundle}"/></span>
		</td>
	</tr>

	<tr class="advancedSetting">
		<th><fmt:message key="railflowPublisher.uploadModeLabel" bundle="${resourceBundle}"/></th>
		<td>
			<props:selectProperty name="${UPLOAD_MODE}" id="${UPLOAD_MODE}">
				<c:set var="uploadMode" value="${propertiesBean.properties[UPLOAD_MODE]}"/>
				<c:forEach var="modeOption" items="${uploadModes}">
					<props:option value="${modeOption.key}" selected="${uploadMode==modeOption.key}">
						<c:out value="${modeOption.value}"/>
					</props:option>
				</c:forEach>
			</props:selectProperty>
			<span class="error" id="error_${UPLOAD_MODE}"></span>
			<span class="smallNote"><fmt:message key="railflowPublisher.uploadModeNote" bundle="${resourceBundle}"/></span>
		</td>
	</tr>

	<tr class="advancedSetting">
		<th><fmt:message key="railflowPublisher.closeRunLabel" bundle="${resourceBundle}"/></th>
		<td>
			<props:checkboxProperty name="${CLOSE_RUN}"/>
			<span class="error" id="error_${CLOSE_RUN}"></span>
			<span class="smallNote"><fmt:message key="railflowPublisher.closeRunNote"
												 bundle="${resourceBundle}"/></span>
		</td>
	</tr>

	<tr class="advancedSetting">
		<th><fmt:message key="railflowPublisher.closePlanLabel" bundle="${resourceBundle}"/></th>
		<td>
			<props:checkboxProperty name="${CLOSE_PLAN}"/>
			<span class="error" id="error_${CLOSE_PLAN}"></span>
			<span class="smallNote"><fmt:message key="railflowPublisher.closePlanNote"
												 bundle="${resourceBundle}"/></span>
		</td>
	</tr>

	<tr class="advancedSetting">
		<th><fmt:message key="railflowPublisher.disableGroupingLabel" bundle="${resourceBundle}"/></th>
		<td>
			<props:checkboxProperty name="${DISABLE_GROUPING}"/>
			<span class="error" id="error_${DISABLE_GROUPING}"></span>
			<span class="smallNote"><fmt:message key="railflowPublisher.disableGroupingNote"
												 bundle="${resourceBundle}"/></span>
		</td>
	</tr>
	<tr class="advancedSetting">
		<th><fmt:message key="railflowPublisher.uploadTimeoutLabel" bundle="${resourceBundle}"/></th>
		<td>
			<props:textProperty name="${UPLOAD_TIMEOUT}" value="${propertiesBean.properties[UPLOAD_TIMEOUT]}"
								className="longField"/>
			<span class="error" id="error_${UPLOAD_TIMEOUT}"></span>
			<span class="smallNote"><fmt:message key="railflowPublisher.uploadTimeoutNote"
												 bundle="${resourceBundle}"/></span>
		</td>
	</tr>
	<tr class="advancedSetting">
		<th><fmt:message key="railflowPublisher.fullCaseNamesAllowedLabel" bundle="${resourceBundle}"/></th>
		<td>
			<props:checkboxProperty name="${FULL_CASE_NAMES_ALLOWED}"/>
			<span class="error" id="error_${FULL_CASE_NAMES_ALLOWED}"></span>
			<span class="smallNote"><fmt:message key="railflowPublisher.fullCaseNamesAllowedNote"
												 bundle="${resourceBundle}"/></span>
		</td>
	</tr>

</l:settingsGroup>

<tr>
	<th><fmt:message key="railflowPublisher.enableDebugLogLabel" bundle="${resourceBundle}"/></th>
	<td>
		<props:checkboxProperty name="${ENABLE_DEBUG_LOG}"/>
		<span class="error" id="error_${ENABLE_DEBUG_LOG}"></span>
		<span class="smallNote"><fmt:message key="railflowPublisher.enableDebugLogNote"
											 bundle="${resourceBundle}"/></span>
	</td>
</tr>


<script>
	function validateTestPath() {
		const testPathWarningSpan = document.getElementById("warning_${TEST_RAIL_TEST_PATH}");
		testPathWarningSpan.style.display = "none";
		const reportFormat = document.getElementById("${RESULT_FORMAT}");
		const testCasePath = document.getElementById("${TEST_RAIL_TEST_PATH}");
		if (reportFormat.value === "TRX" && testCasePath.value && testCasePath.value.split("/").length < 2) {
			testPathWarningSpan.style.display = "block";
		}
	}

	window.onload = function () {
		validateTestPath();
	};
</script>

<style>
	.hidden {
		display: none;
	}
</style>
