<%@page import="io.railflow.teamcity.server.GlobalRailflowSettingsController" %>
<%@page import="jetbrains.buildServer.serverSide.crypt.RSACipher" %>

<%@ taglib prefix="forms" tagdir="/WEB-INF/tags/forms" %>
<%@ include file="/include.jsp" %>
<c:url value="<%=GlobalRailflowSettingsController.CONTROLLER_PATH%>" var="url"/>
<jsp:useBean id="globalRailflowSettings" scope="request" type="io.railflow.teamcity.server.GlobalRailflowSettings"/>
<fmt:setBundle basename="i18n.Messages" var="resourceBundle"/>

<bs:linkCSS dynamic="true">
    /css/admin/adminMain.css
    /css/admin/serverConfig.css
    ${teamcityPluginResourcesPath}css/customStyle.css
</bs:linkCSS>

<bs:linkScript>
    ${teamcityPluginResourcesPath}js/globalRailflowSettingsAdminPage.js
</bs:linkScript>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
</head>
<body>
<div id="settingsContainer">
    <form id="form" name="form" action="${url}" method="post" onsubmit="return Railflow.SettingsForm.submitSettings();">
        <div class="railflowSettingsPage">
            <bs:messages key="settingsSaved"/>
            <table class="runnerFormTable">
                <tr>
                    <th colspan="3">
                        <label><fmt:message key="globalRailflowSettings.railflowLicense" bundle="${resourceBundle}"/> <l:star/></label>
                    </th>
                </tr>
                <tr>
                    <th colspan="3">
                        <label><fmt:message key="globalRailflowSettings.railflowLicenseTitle" bundle="${resourceBundle}"/> </label>
                    </th>
                </tr>
                <tr>
                    <td>
                        &nbsp;
                    </td>
                    <td colspan="2" class="nopadding">
                        <table class="licenseInputTable">
                            <tr>
                                <td>
                                    <input type="radio" id="licenseKey" name="license" value="licenseKey"
                                           onclick="Railflow.SettingsForm.showLicenseOption('licenseKey')">
                                    <label for="licenseKey"><fmt:message key="globalRailflowSettings.railflowLicenseKey"
                                                                         bundle="${resourceBundle}"/></label>
                                    <span class="smallNote"><fmt:message key="globalRailflowSettings.railflowLicenseKeyNote"
                                                                         bundle="${resourceBundle}"/></span>
                                </td>
                            </tr>
                            <tr id="licenseKeyContainer" style="display: none">
                                <td>
                               <span>
                                 <input type="password" id="licenseKeyInput" name="licenseKey" value=""/>
                                 <INPUT type="button" id="activateLicenseBtn" name="licenseBtn"
                                        value='<fmt:message key="globalRailflowSettings.railflowActivateLicenseButtonLabel" bundle="${resourceBundle}"/>'
                                        onclick="Railflow.SettingsForm.activateLicense()"/>
                               </span>
                                </td>
                            </tr>
                            <tr>
                                <td>
                                    <input type="radio" id="licenseFile" name="license" value="licenseFile"
                                           onclick="Railflow.SettingsForm.showLicenseOption(' licenseFile')">
                                    <label for="licenseFile"><fmt:message key="globalRailflowSettings.railflowLicenseFile" bundle="${resourceBundle}"/></label>
                                    <span class="smallNote"><fmt:message key="globalRailflowSettings.railflowLicenseFileNote"
                                                                         bundle="${resourceBundle}"/></span></td>
                            </tr>
                            <tr id="licenseFileContainer" style="display: none">
                                <td>
                                    <span>
                                         <input type="file" id="licenseFileInput" name="licenseFile" value="Upload License" accept=".skm"/>
                                         <INPUT type="button" id="uploadLicenseBtn" name="licenseBtn"
                                                value='<fmt:message key="globalRailflowSettings.railflowActivateLicenseButtonLabel" bundle="${resourceBundle}"/>'
                                                onclick="Railflow.SettingsForm.uploadLicense()"/>
                                   </span>
                                </td>
                            </tr>
                            <tr id="licenseMessageRow" style="display: none">
                                <td colspan="2">
                                    <span id="licenseMessage"></span>
                                </td>
                            </tr>
                        </table>
                    </td>
                </tr>
                <tr>
                    <th>
                        <label label><fmt:message key="globalRailflowSettings.railflowLicenseExpirationDate"
                                                  bundle="${resourceBundle}"/></label>
                    </th>
                    <td colspan="2">
                        <forms:textField id="expirationDate" name="expirationDate"
                                         value="${globalRailflowSettings.licenseExpirationDate}"
                                         readonly="true"/>
                    </td>
                </tr>

                <tr>
                    <th>
                        <label><fmt:message key="globalRailflowSettings.railflowTestRailServers"
                                            bundle="${resourceBundle}"/><l:star/></label>
                    </th>
                    <td>
                        <forms:textField id="defaultTestRailName" name="defaultName" defaultText="New TestRail Server"
                                         style="display:none"/>
                        <forms:textField id="defaultTestRailUrl" name="defaultTestRailUrl"
                                         defaultText="https://testrail" style="display:none"/>
                        <forms:textField id="defaultTestRailUsername" name="defaultTestRailUsername"
                                         defaultText="user@company.com" style="display:none"/>
                        <forms:passwordField id="defaultTestRailPassword" name="defaultTestRailPassword"
                                             style="display:none; padding-left: 3px;"/>
                        <forms:textField id="noOfServers" name="noOfServers" value="0" style="display:none"/>
                        <span class="error" id="defaultErrorSpan"></span>

                        <table id="defaultTestrailServers" class="serverMetadataTable" style="display:none">
                            <tr>
                                <th>
                                    <label><fmt:message key="globalRailflowSettings.railflowTestRailServer"
                                                        bundle="${resourceBundle}"/></label>
                                </th>
                                <td>
                                    <INPUT type="button" value="Delete Instance" onclick="return this.parentNode.parentNode.parentNode.parentNode.remove();"/>
                                </td>
                            </tr>
                            <tr>
                                <th>
                                    <label class="labelC1"><fmt:message key="globalRailflowSettings.railflowTestRailServerName" bundle="${resourceBundle}"/>
                                        <l:star/></label>
                                </th>
                                <td>
                                    <span class="smallNote"><fmt:message key="globalRailflowSettings.railflowTestRailServerNameNote"
                                                                         bundle="${resourceBundle}"/></span>
                                </td>
                            </tr>
                            <tr>
                                <th>
                                    <label class="labelC1"><fmt:message key="globalRailflowSettings.railflowTestRailServerUrl" bundle="${resourceBundle}"/>
                                        <l:star/></label>
                                </th>
                                <td>
                                    <span class="smallNote"><fmt:message key="globalRailflowSettings.railflowTestRailServerUrlNote"
                                                                         bundle="${resourceBundle}"/></span>
                                </td>
                            </tr>
                            <tr>
                                <th>
                                    <label class="labelC1"><fmt:message key="globalRailflowSettings.railflowTestRailServerUsername" bundle="${resourceBundle}"/>
                                        <l:star/></label>
                                </th>
                                <td>
                                    <span class="smallNote"><fmt:message key="globalRailflowSettings.railflowTestRailServerUsernameNote"
                                                                         bundle="${resourceBundle}"/></span>
                                </td>
                            </tr>
                            <tr rowspan="2">
                                <th>
                                    <label class="labelC1"><fmt:message key="globalRailflowSettings.railflowTestRailServerPassword" bundle="${resourceBundle}"/>
                                        <l:star/></label>
                                </th>
                                <td>
                                    <span class="smallNote"><fmt:message key="globalRailflowSettings.railflowTestRailServerPasswordNote"
                                                                         bundle="${resourceBundle}"/></span>
                                </td>
                            </tr>
                        </table>
                        <div id="testRailserversDiv">

                            <c:choose>
                                <c:when test="${null == globalRailflowSettings.getTestRailServers() || globalRailflowSettings.getTestRailServers().size() == 0}">
                                    <table id="testrailServers" class="serverMetadataTable">
                                        <tr>
                                            <th>
                                                <label><fmt:message key="globalRailflowSettings.railflowTestRailServer" bundle="${resourceBundle}"/></label>
                                            </th>
                                            <td>
                                                <INPUT type="button" value="Delete Instance"
                                                       onclick="return this.parentNode.parentNode.parentNode.parentNode.remove();"/>
                                            </td>
                                        </tr>
                                        <tr>
                                            <th>
                                                <label class="labelC1"><fmt:message key="globalRailflowSettings.railflowTestRailServerName"
                                                                                    bundle="${resourceBundle}"/> <l:star/></label>
                                            </th>
                                            <td>
                                                <forms:textField id="name" name="name" defaultText="New TestRail Server"/>
                                                <span class="smallNote"><fmt:message key="globalRailflowSettings.railflowTestRailServerNameNote"
                                                                                     bundle="${resourceBundle}"/></span>
                                            </td>
                                        </tr>
                                        <tr>
                                            <th>
                                                <label class="labelC1"><fmt:message key="globalRailflowSettings.railflowTestRailServerUrl"
                                                                                    bundle="${resourceBundle}"/> <l:star/></label>
                                            </th>
                                            <td>
                                                <forms:textField id="testrailUrl" name="testrailUrl" defaultText="https://testrail"/>
                                                <span class="smallNote"><fmt:message key="globalRailflowSettings.railflowTestRailServerUrlNote"
                                                                                     bundle="${resourceBundle}"/></span>
                                            </td>
                                        </tr>
                                        <tr>
                                            <th>
                                                <label class="labelC1"><fmt:message key="globalRailflowSettings.railflowTestRailServerUsername"
                                                                                    bundle="${resourceBundle}"/> <l:star/></label>
                                            </th>
                                            <td>
                                                <forms:textField id="testrailUsername" name="testrailUsername" defaultText="user@company.com"/>
                                                <span class="smallNote"><fmt:message key="globalRailflowSettings.railflowTestRailServerUsernameNote"
                                                                                     bundle="${resourceBundle}"/></span>
                                            </td>
                                        </tr>
                                        <tr rowspan="2">
                                            <th>
                                                <label class="labelC1"><fmt:message key="globalRailflowSettings.railflowTestRailServerPassword"
                                                                                    bundle="${resourceBundle}"/> <l:star/></label>
                                            </th>
                                            <td>
                                                <forms:passwordField id="testRailPassword" name="testRailPassword" style="padding-left: 3px;"/>
                                                <span class="smallNote"><fmt:message key="globalRailflowSettings.railflowTestRailServerPasswordNote"
                                                                                     bundle="${resourceBundle}"/></span>
                                            </td>
                                        </tr>
                                    </table>
                                </c:when>
                                <c:otherwise>
                                    <c:forEach var="testRailserver" items="${globalRailflowSettings.testRailServers}" varStatus="loop">
                                        <table id="testrailServers" class="serverMetadataTable">

                                        <tr>
                                            <th>
                                                <label><fmt:message key="globalRailflowSettings.railflowTestRailServer" bundle="${resourceBundle}"/></label>
                                            </th>
                                            <td>
                                                <INPUT type="button" value="Delete Instance"
                                                       onclick="return this.parentNode.parentNode.parentNode.parentNode.remove();"/>
                                            </td>
                                        </tr>
                                        <tr>
                                            <th>
                                                <label class="labelC1"><fmt:message key="globalRailflowSettings.railflowTestRailServerName"
                                                                                    bundle="${resourceBundle}"/> <l:star/></label>
                                            </th>
                                            <td>
                                                <forms:textField id="name${loop.count}" name="name${loop.count}" value="${testRailserver.value.name}"/>
                                                <span class="smallNote"><fmt:message key="globalRailflowSettings.railflowTestRailServerNameNote"
                                                                                     bundle="${resourceBundle}"/></span>
                                            </td>
                                        </tr>
                                        <tr>
                                            <th>
                                                <label class="labelC1"><fmt:message key="globalRailflowSettings.railflowTestRailServerUrl"
                                                                                    bundle="${resourceBundle}"/> <l:star/></label>
                                            </th>
                                            <td>
                                                <forms:textField id="testrailUrl${loop.count}" name="testrailUrl${loop.count}"
                                                                 value="${testRailserver.value.url}"/>
                                                <span class="smallNote"><fmt:message key="globalRailflowSettings.railflowTestRailServerUrlNote"
                                                                                     bundle="${resourceBundle}"/></span>
                                            </td>
                                        </tr>
                                        <tr>
                                            <th>
                                                <label class="labelC1"><fmt:message key="globalRailflowSettings.railflowTestRailServerUsername"
                                                                                    bundle="${resourceBundle}"/> <l:star/></label>
                                            </th>
                                            <td>
                                                <forms:textField id="testrailUsername${loop.count}" name="testrailUsername${loop.count}"
                                                                 value="${testRailserver.value.userName}"/>
                                                <span class="smallNote"><fmt:message key="globalRailflowSettings.railflowTestRailServerUsernameNote"
                                                                                     bundle="${resourceBundle}"/></span>
                                            </td>
                                        </tr>
                                        <tr rowspan="2">
                                            <th>
                                                <label class="labelC1"><fmt:message key="globalRailflowSettings.railflowTestRailServerPassword"
                                                                                    bundle="${resourceBundle}"/> <l:star/></label>
                                            </th>
                                            <td>
                                                <forms:passwordField id="testRailPassword${loop.count}" name="testRailPassword${loop.count}"
                                                                     encryptedPassword="${testRailserver.value.getEncyptedPassword()}"
                                                                     style="padding-left: 3px;"/>
                                                <span class="smallNote"><fmt:message key="globalRailflowSettings.railflowTestRailServerPasswordNote"
                                                                                     bundle="${resourceBundle}"/></span>
                                            </td>
                                        </tr>
                                        </table>
                                    </c:forEach>
                                </c:otherwise>
                            </c:choose>
                        </div>
                        <INPUT type="button" value="Add Instance"
                               onclick="Railflow.SettingsForm.addServer('defaultTestrailServers', 'testRailserversDiv', 'testRail')"/>
                        <br/><br/>
                        <span class="error" id="errorSaveServers"></span>
                    </td>
                </tr>
                <tr>
                    <th>
                        <fmt:message key="globalRailflowSettings.uploadStatistics" bundle="${resourceBundle}"/>
                    </th>
                    <td colspan="2" nowrap>
                        <input type="checkbox" id="uploadStatistics"
                               name="uploadStatistics" ${globalRailflowSettings.isUploadStatisticsChecked()}>
                        <fmt:message key="globalRailflowSettings.uploadStatisticsNote" bundle="${resourceBundle}"/>
                    </td>
                </tr>
            </table>
        </div>

        <div class="saveButtonsBlock">
            <fmt:message key="buttonSave" var="btnSave" bundle="${resourceBundle}"/>
            <forms:submit type="submit" label="${btnSave}"/>
            <input type="hidden" id="submitSettings" name="submitSettings" value="store"/>
            <input type="hidden" id="publicKey" name="publicKey"
                   value="<c:out value='${RSACipher.getHexEncodedPublicKey()}'/>"/>
            <forms:saving/>
        </div>
    </form>
</div>
<forms:modified/>
</body>
</html>

<script type="text/javascript">
    const successMessage = '<fmt:message key="globalRailflowSettings.railflowLicenseValidationSuccessMessage" bundle="${resourceBundle}"/>';
</script>
