<%@ page import="io.railflow.teamcity.server.RailflowPublisherConfigController" %>
<%@ taglib prefix="props" tagdir="/WEB-INF/tags/props" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@include file="railflowConstants.jsp" %>

<fmt:setBundle basename="i18n.Messages" var="resourceBundle"/>

<props:viewWorkingDirectory/>

<div class="parameter">
	<fmt:message key="railflowPublisher.testRailServerNameLabel" bundle="${resourceBundle}"/>
	<strong><props:displayValue name="${TEST_RAIL_SERVER_NAME}"/></strong>
</div>

<div class="parameter">
	<fmt:message key="railflowPublisher.testRailOverridingUserNameLabel" bundle="${resourceBundle}"/>
	<strong><props:displayValue name="${PROPERTY_TEST_RAIL_OVERRIDING_USERNAME}"/></strong>
</div>

<div class="parameter">
	<fmt:message key="railflowPublisher.projectLabel" bundle="${resourceBundle}"/>
	<strong><props:displayValue name="${TEST_RAIL_PROJECT}"/></strong>
</div>

<div class="parameter">
	<fmt:message key="railflowPublisher.failBuildIfUploadUnsuccessfulLabel" bundle="${resourceBundle}"/>
	<!-- uncheckedValue does not work because of the bug in props:displayCheckboxValue tag -->
	<strong><props:displayCheckboxValue name="${FAIL_BUILD_IF_UPLOAD_FAILS}" uncheckedValue="false"
										checkedValue="true"/></strong>
</div>

<div class="parameter">
	<fmt:message key="railflowPublisher.resultFilesPatternLabel" bundle="${resourceBundle}"/>
	<strong><props:displayValue name="${RESULT_FILES_PATTERN}"/></strong>
</div>

<div class="parameter">
	<fmt:message key="railflowPublisher.resultFormatLabel" bundle="${resourceBundle}"/>
	<strong>
		<c:out value="${RailflowPublisherConfigController.getReportFormatValue(propertiesBean.properties[RESULT_FORMAT])}"/>
	</strong>
</div>

<div class="parameter">
	<fmt:message key="railflowPublisher.searchModeLabel" bundle="${resourceBundle}"/>
	<strong>
		<c:out value="${RailflowPublisherConfigController.getSearchModeValue(propertiesBean.properties[SEARCH_MODE])}"/>
	</strong>
</div>

<div class="parameter">
	<fmt:message key="railflowPublisher.testPathLabel" bundle="${resourceBundle}"/>
	<strong><props:displayValue name="${TEST_RAIL_TEST_PATH}"/></strong>
</div>

<div class="parameter">
	<fmt:message key="railflowPublisher.testPlanLabel" bundle="${resourceBundle}"/>
	<strong><props:displayValue name="${TEST_RAIL_TEST_PLAN}"/></strong>
</div>

<div class="parameter">
	<fmt:message key="railflowPublisher.testRunLabel" bundle="${resourceBundle}"/>
	<strong><props:displayValue name="${TEST_RAIL_TEST_RUN}"/></strong>
</div>

<div class="parameter">
	<fmt:message key="railflowPublisher.testRunIdLabel" bundle="${resourceBundle}"/>
	<strong><props:displayValue name="${TEST_RAIL_TEST_RUN_ID}"/></strong>
</div>

<div class="parameter">
	<fmt:message key="railflowPublisher.milestonePathLabel" bundle="${resourceBundle}"/>
	<strong><props:displayValue name="${TEST_RAIL_MILESTONES_PATH}"/></strong>
</div>

<div class="parameter">
	<fmt:message key="railflowPublisher.smartTestFailureAssignmentLabel" bundle="${resourceBundle}"/>
	<strong><props:displayValue name="${SMART_TEST_FAILURE_ASSIGNMENT}"/></strong>
</div>

<div class="parameter">
	<fmt:message key="railflowPublisher.caseTypeLabel" bundle="${resourceBundle}"/>
	<strong><props:displayValue name="${TEST_RAIL_CASE_TYPE}"/></strong>
</div>

<div class="parameter">
	<fmt:message key="railflowPublisher.casePriorityLabel" bundle="${resourceBundle}"/>
	<strong><props:displayValue name="${TEST_RAIL_CASE_PRIORITY}"/></strong>
</div>

<div class="parameter">
	<fmt:message key="railflowPublisher.testRailTemplateLabel" bundle="${resourceBundle}"/>
	<strong><props:displayValue name="${TEST_RAIL_TEMPLATE}"/></strong>
</div>

<div class="parameter">
	<fmt:message key="railflowPublisher.testRailCustomCaseFieldsLabel" bundle="${resourceBundle}"/>
	<strong><props:displayValue name="${TEST_RAIL_CUSTOM_CASE_FIELDS}"/></strong>
</div>

<div class="parameter">
	<fmt:message key="railflowPublisher.customResultFieldsLabel" bundle="${resourceBundle}"/>
	<strong><props:displayValue name="${TEST_RAIL_CUSTOM_RESULT_FIELDS}"/></strong>
</div>

<div class="parameter">
	<fmt:message key="railflowPublisher.configNamesLabel" bundle="${resourceBundle}"/>
	<strong><props:displayValue name="${CONFIG_NAME}"/></strong>
</div>

<div class="parameter">
	<fmt:message key="railflowPublisher.caseSearchFieldLabel" bundle="${resourceBundle}"/>
	<strong><props:displayValue name="${CASE_SEARCH_FIELD}"/></strong>
</div>

<div class="parameter">
	<fmt:message key="railflowPublisher.tagsFieldNameLabel" bundle="${resourceBundle}"/>
	<strong><props:displayValue name="${TAGS_FIELD_NAME}"/></strong>
</div>

<div class="parameter">
	<fmt:message key="railflowPublisher.uploadModeLabel" bundle="${resourceBundle}"/>
	<strong>
		<c:out value="${RailflowPublisherConfigController.getUploadModeValue(propertiesBean.properties[UPLOAD_MODE])}"/>
	</strong>
</div>

<div class="parameter">
	<fmt:message key="railflowPublisher.closeRunLabel" bundle="${resourceBundle}"/>
	<strong><props:displayCheckboxValue name="${CLOSE_RUN}" uncheckedValue="false" checkedValue="true"/></strong>
</div>

<div class="parameter">
	<fmt:message key="railflowPublisher.closePlanLabel" bundle="${resourceBundle}"/>
	<strong><props:displayCheckboxValue name="${CLOSE_PLAN}" uncheckedValue="false" checkedValue="true"/></strong>
</div>

<div class="parameter">
	<fmt:message key="railflowPublisher.disableGroupingLabel" bundle="${resourceBundle}"/>
	<strong><props:displayCheckboxValue name="${DISABLE_GROUPING}" uncheckedValue="false" checkedValue="true"/></strong>
</div>

<div class="parameter">
	<fmt:message key="railflowPublisher.uploadTimeoutLabel" bundle="${resourceBundle}"/>
	<strong><props:displayValue name="${UPLOAD_TIMEOUT}"/></strong>
</div>

<div class="parameter">
	<fmt:message key="railflowPublisher.fullCaseNamesAllowedLabel" bundle="${resourceBundle}"/>
	<strong><props:displayCheckboxValue name="${FULL_CASE_NAMES_ALLOWED}" uncheckedValue="false"
										checkedValue="true"/></strong>
</div>

<div class="parameter">
	<fmt:message key="railflowPublisher.enableDebugLogLabel" bundle="${resourceBundle}"/>
	<strong><props:displayValue name="${ENABLE_DEBUG_LOG}"/></strong>
</div>
